#include <LPC214x.H>
#include <stdio.h>

#define CPU_CLOCK   60000000                //  
#define DATA_FREQ   8000                    //  
#define VPB_CLOCK   (CPU_CLOCK/2)           //  VPB
#define TIM_TICK    (VPB_CLOCK/DATA_FREQ)   //  

#include "sound.h"
extern unsigned int Index;     //   
extern unsigned int PointSound;  //   

//   
void timer0(void) __irq
{
 switch (PointSound)
   {
   case 0: if (Index < SoundCount[PointSound]) DACR = SoundData0[Index++]<<6; //    ,     //SoundCount
           else PointSound=0xff;
		   break; 
   case 1: if (Index < SoundCount[PointSound]) DACR = SoundData1[Index++]<<6; //    ,    
           else PointSound=0xff; 
		   break;
   case 2: if (Index < SoundCount[PointSound]) DACR = SoundData2[Index++]<<6; //    ,    
           else PointSound=0xff; 
		   break; 
   default: break;
   }

 T0IR        = 1; //   
 VICVectAddr = 0; //   
}

//   
void Init_Timer0(void)
{
 T0MR0 = TIM_TICK - 1;                     /* Timer0 Match Value 0           */
 T0MCR = 3;                                /* Interrupt and Reset on MR0     */
 T0TCR = 1;                                /* Timer0 Enable                  */
 VICVectAddr0 = (unsigned long)timer0;     /* Set Interrupt Vector in 0      */
 VICVectCntl0 = 0x20 | 4;                  /* Use it for Timer0 Interrupt    */
 VICIntEnable = 0x00000010;                /* Enable Timer0 Interrupt        */
}